searchData={"items":[{"type":"behaviour","title":"Conpipe.Converter","doc":"Behavior for Conpipe Connectors","ref":"Conpipe.Converter.html"},{"type":"callback","title":"Conpipe.Converter.convert/2","doc":"","ref":"Conpipe.Converter.html#c:convert/2"},{"type":"module","title":"Conpipe.Converter.Earmark","doc":"This converter uses the `Earmark` conversion engine to transform markdown to HTML.\n\nSee the [Earmark Repo](https://hexdocs.pm/earmark/Earmark.html) for more info.","ref":"Conpipe.Converter.Earmark.html"},{"type":"function","title":"Conpipe.Converter.Earmark.convert/2","doc":"Convert Markdown to HTML using Earmark","ref":"Conpipe.Converter.Earmark.html#convert/2"},{"type":"function","title":"Conpipe.Converter.Earmark.convert/4","doc":"The `convert/4` function can be called directly from Tableau.\n\n```elixir\n# config/config.exs\nconfig :tableau, :config,\n  url: \"http://localhost:4999\",\n  converters: [\n    md: Conpipe.Converter.Earmark\n  ]\n```\n\nThe `convert/4` function returns just the converted text. It should not\nbe used in a pipeline.","ref":"Conpipe.Converter.Earmark.html#convert/4"},{"type":"module","title":"Conpipe.Converter.Eex","doc":"This converter uses the `EEx` template engine to transform EEx tags.\n\nSee [EEx Hexdocs](https://hexdocs.pm/eex/1.14/EEx.html) for more info.","ref":"Conpipe.Converter.Eex.html"},{"type":"function","title":"Conpipe.Converter.Eex.convert/2","doc":"Resolve EEx tags","ref":"Conpipe.Converter.Eex.html#convert/2"},{"type":"function","title":"Conpipe.Converter.Eex.convert/4","doc":"The `convert/4` function can be called directly from Tableau.\n\n```elixir\n# config/config.exs\nconfig :tableau, :config,\n  url: \"http://localhost:4999\",\n  converters: [\n    md: Conpipe.Converter.Eex\n  ]\n```\n\nThe `convert/4` function returns just the converted text. It should not\nbe used in a pipeline.","ref":"Conpipe.Converter.Eex.html#convert/4"},{"type":"module","title":"Conpipe.Converter.Mdex","doc":"This converter uses the `MDEx` template engine to transform markdown to HTML.\n\nSee the [MDEx](https://github.com/edgurgel/solid) repo for more information.","ref":"Conpipe.Converter.Mdex.html"},{"type":"function","title":"Conpipe.Converter.Mdex.convert/2","doc":"Convert Markdown to HTML using MDEx","ref":"Conpipe.Converter.Mdex.html#convert/2"},{"type":"function","title":"Conpipe.Converter.Mdex.convert/4","doc":"The `convert/4` function can be called directly from Tableau.\n\n```elixir\n# config/config.exs\nconfig :tableau, :config,\n  url: \"http://localhost:4999\",\n  converters: [\n    md: Conpipe.Converter.Mdex\n  ]\n```\n\nThe `convert/4` function returns just the converted text. It should not\nbe used in a pipeline.","ref":"Conpipe.Converter.Mdex.html#convert/4"},{"type":"module","title":"Conpipe.Converter.Netlify","doc":"This is an experimental converter, that post-processes HTML to rewrite image\nURLs to use Netlify.\n\nSee the Tableau issue https://github.com/elixir-tools/tableau/issues/107 for\nmore background.\n\nThis use case derives from @paradox460's Netlify processor at\n  https://github.com/elixir-tools/tableau/issues/107\n\nTo use, put this converter LAST in the Pipeline, after HTML conversion.","ref":"Conpipe.Converter.Netlify.html"},{"type":"function","title":"Conpipe.Converter.Netlify.convert/2","doc":"Perform HTML post-processing for Netlify image links","ref":"Conpipe.Converter.Netlify.html#convert/2"},{"type":"function","title":"Conpipe.Converter.Netlify.convert/4","doc":"The `convert/4` function can be called directly from Tableau.\n\n```elixir\n# config/config.exs\nconfig :tableau, :config,\n  url: \"http://localhost:4999\",\n  converters: [\n    md: Conpipe.Converter.Netlify\n  ]\n```\n\nThe `convert/4` function returns just the converted text. It should not\nbe used in a pipeline.","ref":"Conpipe.Converter.Netlify.html#convert/4"},{"type":"module","title":"Conpipe.Converter.Noop","doc":"This converter passes `{input, assigns}` thru unchanged.\n\nUsed for testing.","ref":"Conpipe.Converter.Noop.html"},{"type":"function","title":"Conpipe.Converter.Noop.convert/2","doc":"No-op module used for testing","ref":"Conpipe.Converter.Noop.html#convert/2"},{"type":"function","title":"Conpipe.Converter.Noop.convert/4","doc":"The `convert/4` function can be called directly from Tableau.\n\n```elixir\n# config/config.exs\nconfig :tableau, :config,\n  url: \"http://localhost:4999\",\n  converters: [\n    md: Conpipe.Converter.Noop\n  ]\n```\n\nThe `convert/4` function returns just the converted text. It should not\nbe used in a pipeline.","ref":"Conpipe.Converter.Noop.html#convert/4"},{"type":"module","title":"Conpipe.Converter.Solid","doc":"This converter uses the `Solid` template engine to transform Liquid tags.\n\nSee the [Solid](https://github.com/leandrocp/mdex) repo for more information.","ref":"Conpipe.Converter.Solid.html"},{"type":"function","title":"Conpipe.Converter.Solid.convert/2","doc":"Resolve liquid tags using Solid","ref":"Conpipe.Converter.Solid.html#convert/2"},{"type":"function","title":"Conpipe.Converter.Solid.convert/4","doc":"The `convert/4` function can be called directly from Tableau.\n\n```elixir\n# config/config.exs\nconfig :tableau, :config,\n  url: \"http://localhost:4999\",\n  converters: [\n    md: Conpipe.Converter.Solid\n  ]\n```\n\nThe `convert/4` function returns just the converted text. It should not\nbe used in a pipeline.","ref":"Conpipe.Converter.Solid.html#convert/4"},{"type":"module","title":"Conpipe.Converter.SolidMdex","doc":"This converter consumes Markdown text with embedded Liquid tags.\n\nIt uses the `Conpipe.Convert.Solid` to transform the Liquid tags,\nand `Conpipe.Convert.Mdex` to transform Markdown to HTML.","ref":"Conpipe.Converter.SolidMdex.html"},{"type":"function","title":"Conpipe.Converter.SolidMdex.convert/2","doc":"Convert Liquid tags then convert markdown to HTML","ref":"Conpipe.Converter.SolidMdex.html#convert/2"},{"type":"function","title":"Conpipe.Converter.SolidMdex.convert/4","doc":"The `convert/4` function can be called directly from Tableau.\n\n```elixir\n# config/config.exs\nconfig :tableau, :config,\n  url: \"http://localhost:4999\",\n  converters: [\n    md: Conpipe.Converter.SolidMdex\n  ]\n```\n\nThe `convert/4` function returns just the converted text. It should not\nbe used in a pipeline.","ref":"Conpipe.Converter.SolidMdex.html#convert/4"},{"type":"module","title":"Conpipe.Runner","doc":"Functions to run a pipeline","ref":"Conpipe.Runner.html"},{"type":"function","title":"Conpipe.Runner.exec/3","doc":"Exec a pipeline\n\nReturns `output`","ref":"Conpipe.Runner.html#exec/3"},{"type":"function","title":"Conpipe.Runner.reduce/3","doc":"Reduce over a pipeline\n\nReturns `{output, assigns}`","ref":"Conpipe.Runner.html#reduce/3"},{"type":"module","title":"Conpipe.Util","doc":"Utility functions for Conpipe operations.","ref":"Conpipe.Util.html"},{"type":"function","title":"Conpipe.Util.stringify_keys/1","doc":"Recursively converts all atom keys to strings.","ref":"Conpipe.Util.html#stringify_keys/1"},{"type":"extras","title":"Conpipe","doc":"# Conpipe \n\nA Converter Pipeline with a composable library of operations. Conpipe wraps\ntemplate processors (eg EEx, Liquid) and plain-text markup languages (eg\nMarkdown, Asciidoc) to streamline development.\n\nConpipe is:\n- intended for use in Static Site Generators like\n[Tableau](https://github.com/elixir-tools/tableau) \n- designed to be extended\n- EXPERIMENTAL - expect breaking changes","ref":"readme.html"},{"type":"extras","title":"Installation - Conpipe","doc":"Add `conpipe` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:conpipe, github: \"andyl/conpipe\"}\n  ]\nend\n```\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"readme.html#installation"},{"type":"extras","title":"Converters - Conpipe","doc":"A converter is a module with a `convert/2` function that implements the\n`Conpipe.Converter` behavior.  Here's a converter that processes Liquid tags:\n\n```elixir \ndefmodule MyLiquidConverter do\n  @behavior Conpipe.Converter \n\n  def convert({text, assigns}, opts \\\\ []) do\n    {:ok, template} = Solid.parse(text, opts)\n    output = Solid.render!(template, assigns) |> to_string\n    {output, assigns}\n  end\nend\n```\n\nConverters can be chained in Elixir pipes:\n\n```elixir\ndefmodule My.DoItAllConverter do \n  @behavior Conpipe.Converter \n\n  def convert({text, assigns}, _opts \\\\ []) do \n    {text, assigns} \n    |> Conpipe.Converter.Solid.convert()\n    |> MyConverter.convert()\n    |> Conpipe.Converter.Mdex.convert()\n    |> MyHtmlPostProcessor.convert()\n  end\nend\n```\n\nConverters can be composed and run in a pipeline:\n\n```elixir\n[Conpipe.Converter.Solid, MyConverter, Conpipe.Converter.Mdex] \n|> Conpipe.Runner.reduce(input, assigns)\n```\n\nThis project ships with a library of converters that can be reused across applications: \n\nMarkup Languages\n- `Conpipe.Converter.Earmark` - Markdown HTML\n- `Conpipe.Converter.Mdex` - Markdown to HTML\n \nTemplate Processors \n- `Conpipe.Converter.Eex` - EEx template language \n- `Conpipe.Converter.Solid` - Liquid template language","ref":"readme.html#converters"},{"type":"extras","title":"Tableau Integration - Conpipe","doc":"Adding `use Conpipe.TableauAdapter` to a converter provides a `convert/4`\nfunction that can be called directly from Tableau.\n\n```elixir \ndefmodule MyConverter do \n  @behavior Conpipe.Converter \n  use Conpipe.TableauAdapter \n\n  def convert({text, assigns}, _opts \\\\ []) do \n    {text, assigns} \n    |> Conpipe.Converter.Solid.convert()\n    |> Conpipe.Converter.Mdex.convert()\n  end\nend\n```\n\nThen in `config/config.exs` \n\n```elixir \nconfig :tableau, :config,\n  url: \"http://localhost:4999\",\n  converters: [\n    md: MyConverter\n  ]\n```\n\nAll converters in this package use `TableauAdapter`.","ref":"readme.html#tableau-integration"},{"type":"extras","title":"Contributions - Conpipe","doc":"Pull Requests welcome!  \n\nPR's require [Conventional\nCommits](https://www.conventionalcommits.org/en/v1.0.0/), passing tests and\nformatted code. (`mix format`)\n\nTo auto-exec validations with pre-commit hooks, find setup scripts in the\n`.hooks` directory.","ref":"readme.html#contributions"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}